import geomerative.*;        // Library importieren

RShape grp;                  // Hierdrin ist die Vektorgrafik gespeichert. Rshape ist der Variablentyp/Klasse
RPoint[][] pointPaths;       // Darin werden die einzelnen Punkte gespeichert. 

float xmag, ymag, newYmag, newXmag = 0;    // irgendwelche Größen, wahrscheinlich irrelevant
float z = 0;                               // float

boolean ignoringStyles = false;            // weiß Felix auch nicht

void setup(){
  size(600, 600, P3D);                     // Fenstergröße und Dimension

  // VERY IMPORTANT: Allways initialize the library before using it
  RG.init(this);
  RG.ignoreStyles(ignoringStyles);
  
  RG.setPolygonizer(RG.ADAPTATIVE);        // bestimmt, dass der Winkel zwischen 3 aufeinander folgenden Punkten nicht zu spitz wird
  
  grp = RG.loadShape("bot1.svg");          // lädt Datei (data Ordner)
  grp.centerIn(g, 100, 1, 1);              // zentriert Grafik
  
  pointPaths = grp.getPointsInPaths();     // wandelt Vektorgrafik aus grp in einzelne Punkte um und speichert in pointPaths
}

void draw(){
  translate(width/2, height/2);            // zentriert Koordinatensystem 
  
  newXmag = mouseX/float(width) * TWO_PI;    // unnötig
  newYmag = mouseY/float(height) * TWO_PI;   // unnötig
  
  float diff = xmag-newXmag;
  if (abs(diff) >  0.01) { xmag -= diff/4.0; }
  
  diff = ymag-newYmag;
  if (abs(diff) >  0.01) { ymag -= diff/4.0; }
  
  rotateX(-ymag); 
  rotateY(-xmag); 
  
  background(0);
  stroke(255);
  noFill();                                  
  
  z = 10 * sin( frameCount/50.0 * PI);               // bis hier unnötig
  
  for(int i = 0; i<pointPaths.length; i++){          // geht Anzahl der in der Vektorgrafik existierenden Linien durch
    translate(0,0,z);                                // unnötig

    if (pointPaths[i] != null) {                     // falls die Linie Punkte enthält
      beginShape();                                  // beginnt zeichnen
      for(int j = 0; j<pointPaths[i].length; j++){   // gehe alle Punkte in der Linie durch
        vertex(pointPaths[i][j].x, pointPaths[i][j].y);  // macht Punkt an i. Linie und j. Punkt x bzw. y Koordinate
      }
      endShape();                                    // hört auf mit zeichnen
    }
  }
}

void mousePressed(){                                 // unnötig
  ignoringStyles = !ignoringStyles;
  RG.ignoreStyles(ignoringStyles);
}